Index: trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 633)
+++ trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 635)
@@ -462,73 +1097,672 @@
 
 
-c************************************************
-c     co2,202.6,210.0
-c************************************************
-
-      indexint=32
-         do i=1,nz
-            aux2(nz-i+1) = co2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,1,nz2-i+1)
-            aux4(i) = c1(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
+c**************************************************
+c      co, 119.6-167.0nm
+c**************************************************
+
+      do indexint=25,29
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $           h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,11,nz2-i+1)
+            aux4(i) = c25_29(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
            if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-               jfotsout(indexint,1,i) = aux1(nz-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))*
-     $           (1+alfa(indexint,i)*(t2(i)-t0(i)))
-            else
-               jfotsout(indexint,1,i)=0.
-            end if
-         enddo
-
-
-c************************************************
-c     h2o2,202.6,210.0
-c************************************************
-
-      indexint=32
-         do i=1,nz
-            aux2(nz-i+1) = co2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,6,nz2-i+1)
-            aux4(i) = c1(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,6,i) = aux1(nz-i+1) 
+            jfotsout(indexint,11,i) = aux1(nlayermx-i+1)
      $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
             else
-               jfotsout(indexint,6,i)=0.
+               jfotsout(indexint,11,i) = 0.
             end if
          enddo
-
-
-c************************************************
-c     h2o2,210.1,337.5
-c************************************************
+      end do
+
+
+      !Only if Nitrogen or ionospheric chemistry requested
+      if(chemthermod.ge.2) then
+
+c**************************************************
+c      no, 119.6-167.0nm
+c**************************************************
+
+         do indexint=25,29
+            do i=1,nlayermx
+               aux2(nlayermx-i+1)=co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $              h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
+            end do
+            do i=1,nz2
+               aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
+               aux4(i) = c25_29(nz2-i+1)
+            enddo
+            call interpfast 
+     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            do i=1,nlayermx
+               if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
+     $              .lt.60.) then
+                  jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
+     $             *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+               else
+                  jfotsout(indexint,10,i) = 0.
+               end if
+            enddo
+         end do
+
+
+c**************************************************
+c      no2, 119.6-167.0nm
+c**************************************************
+
+         do indexint=25,29
+            do i=1,nlayermx
+               aux2(nlayermx-i+1)=co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $              h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
+            end do
+            do i=1,nz2
+               aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
+               aux4(i) = c25_29(nz2-i+1)
+            enddo
+            call interpfast 
+     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            do i=1,nlayermx
+               if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
+     $              .lt.60.) then
+                  jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
+     $             *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+               else
+                  jfotsout(indexint,13,i) = 0.
+               end if
+            enddo
+         end do
+
+         endif !Of chemthermod >= 2
+
+
+c**************************************************
+c      co2, 167.0-202.5nm
+c**************************************************
+
+      do indexint=30,31
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
+     $           h2o2colx(i) + nocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
+            aux4(i) = c30_31(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+               jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
+     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+     $           *(1+alfa(indexint,i)*(t2(i)-t0(i)))               
+            else
+               jfotsout(indexint,1,i) = 0.
+            end if
+         enddo
+      end do
+
+
+c**************************************************
+c      o2, 167.0-202.5nm
+c**************************************************
+
+      do indexint=30,31
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $           h2o2colx(i) + nocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
+            aux4(i) = c30_31(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+            jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
+     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+            else
+               jfotsout(indexint,2,i)=0.
+            end if
+         enddo
+      end do
+
+
+c**************************************************
+c      h2o, 167.0-202.5nm
+c**************************************************
+
+      do indexint=30,31
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $           h2o2colx(i) + nocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,4,nz2-i+1)
+            aux4(i) = c30_31(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+            jfotsout(indexint,4,i) = aux1(nlayermx-i+1)
+     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+            else
+               jfotsout(indexint,4,i) = 0.
+            end if
+         enddo
+      end do
+
+
+c**************************************************
+c      h2o2, 167.0-202.5nm
+c**************************************************
+
+      do indexint=30,31
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $           h2o2colx(i) + nocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
+            aux4(i) = c30_31(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+            jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
+     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+            else
+               jfotsout(indexint,6,i) = 0.
+            end if
+         enddo
+      end do
+
+
+      !Only if Nitrogen or ionospheric chemistry requested
+      if(chemthermod.ge.2) then
+      
+c**************************************************
+c      no, 167.0-202.5nm
+c**************************************************
+
+         do indexint=30,31
+            do i=1,nlayermx
+               aux2(nlayermx-i+1)=co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $              h2o2colx(i) + nocolx(i) + no2colx(i)
+            end do
+            do i=1,nz2
+               aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
+               aux4(i) = c30_31(nz2-i+1)
+            enddo
+            call interpfast 
+     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            do i=1,nlayermx
+               if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
+     $              .lt.60.) then
+                  jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
+     $              *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+               else
+                  jfotsout(indexint,10,i) = 0.
+               end if
+            enddo
+         end do
+
+
+c**************************************************
+c      no2, 167.0-202.5nm
+c**************************************************
+
+         do indexint=30,31
+            do i=1,nlayermx
+               aux2(nlayermx-i+1)=co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $              h2o2colx(i) + nocolx(i) + no2colx(i)
+            end do
+            do i=1,nz2
+               aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
+               aux4(i) = c30_31(nz2-i+1)
+            enddo
+            call interpfast 
+     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            do i=1,nlayermx
+               if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
+     $              .lt.60.) then
+                  jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
+     $              *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+               else
+                  jfotsout(indexint,13,i) = 0.
+               end if
+            enddo
+         end do
+         
+      endif !Of chemthermod >= 2
+
+c**************************************************
+c     co2, 202.6-210.0nm
+c**************************************************
+
+      indexint=32
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2o2colx(i) + 
+     $        nocolx(i) + no2colx(i)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
+         aux4(i) = c32(nz2-i+1)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+            jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
+     $           *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+     $           *(1+alfa(indexint,i)*(t2(i)-t0(i)))
+         else
+            jfotsout(indexint,1,i)=0.
+         end if
+      enddo
+
+
+c**************************************************
+c     o2, 202.6-210.0nm
+c**************************************************
+
+      indexint=32
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2o2colx(i) + 
+     $        nocolx(i) + no2colx(i)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
+         aux4(i) = c32(nz2-i+1)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+            jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
+     $           *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+         else
+            jfotsout(indexint,2,i)=0.
+         end if
+      enddo
+
+
+c**************************************************
+c     h2o2, 202.6-210.0nm
+c**************************************************
+
+      indexint=32
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2o2colx(i) + 
+     $        nocolx(i) + no2colx(i)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
+         aux4(i) = c32(nz2-i+1)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+            jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
+     $           *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+         else
+            jfotsout(indexint,6,i)=0.
+         end if
+      enddo
+
+
+      !Only if Nitrogen or ionospheric chemistry requested
+      if(chemthermod.eq.2) then
+
+c**************************************************
+c     no, 202.6-210.0nm
+c**************************************************
+
+         indexint=32
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2o2colx(i) + 
+     $           nocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
+            aux4(i) = c32(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
+     $           .lt.60.) then
+               jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
+     $              *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+            else
+               jfotsout(indexint,10,i)=0.
+            end if
+         enddo
+
+
+c**************************************************
+c     no2, 202.6-210.0nm
+c**************************************************
+
+         indexint=32
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2o2colx(i) + 
+     $           nocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
+            aux4(i) = c32(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
+     $           .lt.60.) then
+               jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
+     $              *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+            else
+               jfotsout(indexint,13,i)=0.
+            end if
+         enddo
+         
+      endif !Of chemthermod >= 2
+
+
+c**************************************************
+c     o2, 210.0-231.0nm
+c**************************************************
+
+      indexint=33
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = o2colx(i) + h2o2colx(i) + no2colx(i)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
+         aux4(i) = c33(nz2-i+1)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
+      enddo
+
+
+c**************************************************
+c     h2o2, 210.1-231.0nm
+c**************************************************
 
       indexint=33
       limdown=1.e-20
       limup=1e25
-         do i=1,nz
-            aux2(nz-i+1) = h2o2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,6,nz2-i+1)
-            aux4(i) = ch2o2(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
-            jfotsout(indexint,6,i) = aux1(nz-i+1)
-         enddo
-
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + no2colx(i)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
+         aux4(i) = c33(nz2-i+1)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
+      enddo
+
+
+      !Only if Nitrogen or ionospheric chemistry requested
+      if(chemthermod.ge.2) then
+
+c**************************************************
+c     no2, 210.1-231.0nm
+c**************************************************
+
+         indexint=33
+         limdown=1.e-20
+         limup=1e25
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
+            aux4(i) = c33(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
+         enddo
+
+      endif !Of chemthermod >= 2
+
+
+c**************************************************
+c     o2, 231.-240.nm
+c**************************************************
+
+      indexint=34
+      limdown=1.e-20
+      limup=1e25
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
+     $        no2colx(i)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
+         aux4(i) = c34(nz2-i+1)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
+      enddo
+
+
+c**************************************************
+c     h2o2, 231.0-240.nm
+c**************************************************
+
+      indexint=34
+      limdown=1.e-20
+      limup=1e25
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
+     $        no2colx(i)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
+         aux4(i) = c34(nz2-i+1)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
+      enddo
+
+
+      !Only if Ozone, Nitrogen or ionospheric chem. requested
+      if(chemthermod.ge.1) then
+
+c**************************************************
+c     o3, 231.0-240.nm
+c**************************************************
+
+         indexint=34
+         limdown=1.e-20
+         limup=1e25
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
+     $           no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,7,nz2-i+1)
+            aux4(i) = c34(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,7,i) = aux1(nlayermx-i+1)
+         enddo
+
+      endif !Of chemthermod.ge.1
+
+
+      !Only if nitrogen or ionospheric chemistry requested
+      if(chemthermod.ge.2) then
+
+c**************************************************
+c     no2, 231.0-240.nm
+c**************************************************
+
+         indexint=34
+         limdown=1.e-20
+         limup=1e25
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = h2o2colx(i) + o2colx(i) + o3colx(i) + 
+     $           no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
+            aux4(i) = c34(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
+         enddo
+
+      endif !Of chemthermod >= 2
+
+
+c**************************************************
+c     h2o2, 240.0-337.7nm
+c**************************************************
+
+      indexint=35
+      limdown=1.e-20
+      limup=1e25
+      do i=1,nlayermx
+         aux2(nlayermx-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
+      end do
+      do i=1,nz2
+         aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
+         aux4(i) = c35(nz2-i+1)
+      enddo
+      call interpfast 
+     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+      do i=1,nlayermx
+         jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
+      enddo
+      
+
+      !Only if Ozone, Nitrogen or ionospheric chem. requested
+      if(chemthermod.ge.1) then
+
+c**************************************************
+c     o3, 240.0-337.7nm
+c**************************************************
+
+         indexint=35
+         limdown=1.e-20
+         limup=1e25
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,7,nz2-i+1)
+            aux4(i) = c35(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,7,i) = aux1(nlayermx-i+1)
+         enddo
+
+      endif !Of chemthermod.ge.1
+
+
+      !Only if Nitrogen or ionospheric chemistry requested
+      if(chemthermod.ge.2) then
+
+c**************************************************
+c     no2, 240.0-337.7nm
+c**************************************************
+
+         indexint=35
+         limdown=1.e-20
+         limup=1e25
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = h2o2colx(i) + o3colx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
+            aux4(i) = c35(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
+         enddo
+
+      endif !Of chemthermod.ge.2
+
+
+      !Only if Ozone, Nitrogen or ionospheric chem. requested
+      if(chemthermod.ge.1) then
+
+c**************************************************
+c     o3, 337.7-800.0nm
+c**************************************************
+
+         indexint=36
+         limdown=1.e-20
+         limup=1e25
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = o3colx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,7,nz2-i+1)
+            aux4(i) = c36(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,7,i) = aux1(nlayermx-i+1)
+         enddo
+
+      endif
+
+
+      !Only if Nitrogen or ionospheric chemistry requested
+      if(chemthermod.ge.2) then
+
+c**************************************************
+c     no2, 337.7-800.0nm
+c**************************************************
+
+         indexint=36
+         limdown=1.e-20
+         limup=1e25
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = o3colx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
+            aux4(i) = c36(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
+         enddo
+
+      endif !Of chemthermod.ge.2
       return
 
